<?php

namespace SuperRhino\Utils\SubTable;

interface SubTableInterface {

    /**
     * 子表数量 默认32
     * @return int
     */
    public static function subTableCount(): int;

    /**
     * 子表表名
     * @return string 子表key
     */
    public static function subTableName(string $key): string;

    /**
     * 子表表名 指定后缀
     * @param string $suffix 后缀
     * @return string
     */
    public static function subTableNameBySuffix(string $suffix): string;

    /**
     * 是否使用子表后缀记录表
     * @return bool
     */
    public static function isSuffixRecord();

    /**
     * 子表后缀记录表名 默认使用表名按照规则生成, 可以自己指定
     * @return string
     */
    public static function getSuffixRecordTableName(): string;

    /**
     * 子表后缀缓存key
     * @param mixed $key
     * @return string
     */
    public static function subTableSuffixCacheKey($key): string;

    /**
     * 子表后缀缓存时间 默认1小时
     * @return int
     */
    public static function subTableSuffixCacheTimeout(): int;

    /**
     * 子表后缀列表
     * @return string[]
     */
    public static function getSubTableSuffixList(): array;

    /**
     * 子表字符串后缀
     * @param $key
     * @param bool $isCache
     * @return string
     */
    public static function getSubTableSuffix($key, bool $isCache = true): string;

    /**
     * 创建子表前缀记录表
     */
    public static function suffixRecordTableUp();

    /**
     * 删除子表前缀记录表
     */
    public static function suffixRecordTableDown();
}